//----------------------------------------------------------------------//
//HotQ																	//
//	CtH[(o[W\)								//
//																		//
//----------------------------------------------------------------------//
#include "usr_wic.h"
#include "usr_migemo.h"
#include "UserFunc.h"
#include "UIniFile.h"
#include "HKeyRec.h"
#include "MacStart.h"
#include "ClipList.h"
#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

THotQMainForm *HotQMainForm;

//---------------------------------------------------------------------------
__fastcall THotQMainForm::THotQMainForm(TComponent* Owner) : TForm(Owner)
{
}

//---------------------------------------------------------------------------
//Nbv{[he\t
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::PasteClipboard()
{
	if (hLastFocus==NULL) return;
	DWORD cur_tid = ::GetCurrentThreadId();
	if (cur_tid!=LastThreadID && ::AttachThreadInput(cur_tid, LastThreadID, TRUE)) {
		UINT tmout;
		::SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, 0, &tmout, 0);
		::SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, (PVOID)0, 0);
		::SetForegroundWindow(hLastWnd);
		::SetFocus(hLastFocus);
		::SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, (PVOID)tmout, 0);

		//WM_PASTE œ\t
		if (HotQMainForm->PasteClassList->IndexOf(get_ClassName(hLastFocus))!=-1) {
			::SendMessage(hLastFocus, WM_PASTE, 0, 0);
		}
		//Ctrl + V œ\t
		else {
			Sleep(100);
			::keybd_event(VK_CONTROL, 0, 0, 0);
			::keybd_event('V', 0, 0, 0);
			Sleep(50);
			::keybd_event('V', 0, KEYEVENTF_KEYUP, 0);
			::keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
			Application->ProcessMessages();
		}
		::AttachThreadInput(cur_tid, LastThreadID, FALSE);
	}
}

//---------------------------------------------------------------------------
// t@CGfB^ŊJ
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::EditFile(UnicodeString fnam)
{
	if (!IniEditor.IsEmpty()) {
		if (fnam.Pos(" ")!=0) fnam = "\"" + fnam + "\"";
		UnicodeString prm = IniFile->ReadString("General", "EditParam");
		if (prm.IsEmpty()) {
			prm = fnam;
		}
		else {
			if (prm.Pos("$FILE$")>0)
				prm = ReplaceStr(prm,"$FILE$", fnam);
			else
				prm += (" " + fnam);
		}
		execute_ex(IniEditor, prm);
	}
}

//---------------------------------------------------------------------------
// tH_̃V[gJbgt@Cj[ɓo^
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::RegisterDir(UnicodeString regdir, TMenuItem *mtop)
{
	regdir = ExcludeTrailingPathDelimiter(regdir);
	if (regdir.IsEmpty() || !DirectoryExists(regdir)) return;

	//regdir ȉ̑SĂlnkt@CXgAbv
	TStringList *FilList = new TStringList();
	get_filelist(regdir, FilList, "LNK", PopSorted);

	//`[ڍ쐬
	for (int i=0; i<FilList->Count; i++) {
		UnicodeString fil_nam = FilList->Strings[i].Delete(1, regdir.Length() + 1);
		TMenuItem *pp = mtop;
		int p = fil_nam.Pos("\\");
		while (p>0) {
			UnicodeString fld_nam = fil_nam.SubString(1, p - 1);
			fil_nam.Delete(1, p);
			TMenuItem *fp = NULL;
			for (int j=0; j<pp->Count; j++) {
				TMenuItem *mp = pp->Items[j];
				if (SameText(mp->Caption, fld_nam)) { fp = mp; break; }
			}
			if (fp==NULL) {
				//tH_ǉ
				TMenuItem *ip = new TMenuItem(PopupLauncher);
				ip->Caption 	  = fld_nam;
				ip->OnMeasureItem = PopItemMeasureItem;
				ip->OnDrawItem	  = PopDrawItem;
				ip->Tag 		  = MITM_LAUNCH | MITM_ITM;
				pp->Add(ip);
				pp = ip;
			}
			else {
				pp = fp;
			}
			p = fil_nam.Pos("\\");
		}
		//ڒǉ
		TMenuItem *ip = new TMenuItem(PopupLauncher);
		ip->Caption 	  = ChangeFileExt(fil_nam, EmptyStr);
		ip->OnClick 	  = LauncherItemClick;
		ip->OnMeasureItem = PopItemMeasureItem;
		ip->OnDrawItem	  = PopDrawItem;
		ip->Tag 		  = MITM_LAUNCH | MITM_ITM;
		pp->Add(ip);
	}

	delete FilList;
}

//---------------------------------------------------------------------------
//`()ݒ
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::RecyclePrc()
{
	Screen->Cursor = crHourGlass;

	UnicodeString sct_pop = "PopupMenu";
	UnicodeString sct_gen = "General";
	UnicodeString sct_cmd = "CmdLauncher";
	UnicodeString sct_clp = "ClipboardList";
	UnicodeString tmpstr;

	UnicodeString ini_nam = ChangeFileExt(Application->ExeName, ".INI");
	bool first = (!FileExists(ini_nam));
	if (IniFile==NULL)
		IniFile = new UsrIniFile(ini_nam);
	else
		IniFile->LoadValues();

	int vno = IniFile->ReadInteger(sct_gen, "Version");
	if (vno<get_VersionNo()) {
		IniFile->WriteInteger(sct_gen, "Version", get_VersionNo());
		if (!first) {
			if (vno<160) {
				IniFile->WriteInteger(sct_clp, "Transparent", 	255);
				IniFile->WriteString( sct_clp, "ExceptWord1");
				IniFile->WriteInteger(sct_clp, "MaxLineCnt",	0);
			}
			if (vno<161) {
				IniFile->WriteString( sct_clp, "TextDataBtn1");
				IniFile->WriteString( sct_clp, "TextDataBtn2");
				IniFile->WriteString( sct_clp, "TextDataBtn3");
				IniFile->WriteString( sct_clp, "TextDataBtn4");
				IniFile->WriteString( sct_clp, "TextDataBtn5");
				IniFile->WriteString( sct_clp, "TextDataBtn6");
				IniFile->WriteString( sct_clp, "TextDataBtn7");
				IniFile->WriteString( sct_clp, "TextDataBtn8");
			}
			if (vno<165) {
				IniFile->WriteString( sct_gen, "WmPasteClass");
			}
			if (vno<171) {
				IniFile->WriteString( sct_clp, "SelBgColor");
			}
			if (vno<174) {
				IniFile->WriteString( sct_gen, "MigemoDir");
			}
		}
	}

	if (first) {
		//INIt@CȂꍇftHglŏ
		IniFile->WriteBool(sct_gen, "NoTrayIcon",		false);
		IniFile->WriteString( sct_gen, "Editor");
		IniFile->WriteString( sct_gen, "QxEditor");
		IniFile->WriteString( sct_gen, "MigemoDir");
		IniFile->WriteString( sct_gen, "WmPasteClass");
		for (int i=1; i<=5; i++) IniFile->WriteString("HotKey" + IntToStr(i), "Key");
		IniFile->WriteString( sct_pop, "PopupDir");
		IniFile->WriteString( sct_pop, "PopupFile");
		IniFile->WriteInteger(sct_pop, "PosX", 			-1);
		IniFile->WriteInteger(sct_pop, "PosY", 			-1);
		IniFile->WriteBool(   sct_pop, "Sort",	 		false);
		IniFile->WriteString( sct_pop, "MinWidth");
		IniFile->WriteString( sct_pop, "ItemHeight");
		IniFile->WriteString( sct_pop, "FgColorL");
		IniFile->WriteString( sct_pop, "BgColorL");
		IniFile->WriteString( sct_pop, "SelFgColorL");
		IniFile->WriteString( sct_pop, "SelBgColorL");
		IniFile->WriteString( sct_pop, "FgColorP");
		IniFile->WriteString( sct_pop, "BgColorP");
		IniFile->WriteString( sct_pop, "SelFgColorP");
		IniFile->WriteString( sct_pop, "SelBgColorP");
		IniFile->WriteString( sct_pop, "AkColor");
		IniFile->WriteString( sct_pop, "SelAkColor");
		IniFile->WriteBool(   sct_pop, "SelRaised",		false);
		IniFile->WriteBool(   sct_pop, "NoAkUnderline",	false);
		IniFile->WriteBool(   sct_pop, "AkBold",		false);
		IniFile->WriteString( sct_cmd, "LaunchDir");
		IniFile->WriteInteger(sct_cmd, "ListSize",		10);
		IniFile->WriteBool(   sct_cmd, "Dropdown",		true);
		IniFile->WriteBool(   sct_cmd, "SkipInput",		false);
		IniFile->WriteBool(   sct_cmd, "CnfExecute",	false);
		IniFile->WriteInteger(sct_cmd, "ExeDelay",		250);
		IniFile->WriteString( sct_cmd, "FontName");
		IniFile->WriteInteger(sct_cmd, "FontSize",		10);
		IniFile->WriteString( sct_cmd, "FgColorK");
		IniFile->WriteString( sct_cmd, "BgColorK");
		IniFile->WriteString( sct_cmd, "FgColorC");
		IniFile->WriteString( sct_cmd, "BgColorC");
		IniFile->WriteString( sct_cmd, "CnfSound");
		IniFile->WriteString( sct_cmd, "NgSound");
		IniFile->WriteBool(   sct_clp, "Enable",		false);
		IniFile->WriteBool(   sct_clp, "SaveHistory",	false);
		IniFile->WriteString( sct_clp, "ClipDataFile",	"CLIPDATA.txt");
		IniFile->WriteString( sct_clp, "TextDataFile",	"TEXTDATA.txt");
		IniFile->WriteInteger(sct_clp, "MaxItems", 		50);
		IniFile->WriteInteger(sct_clp, "MaxTextLen", 	0);
		IniFile->WriteInteger(sct_clp, "MaxLineCnt",	0);
		IniFile->WriteString( sct_clp, "FontName");
		IniFile->WriteInteger(sct_clp, "FontSize",		10);
		IniFile->WriteInteger(sct_clp, "LineSpace", 	0);
		IniFile->WriteString( sct_clp, "FgColorL");
		IniFile->WriteString( sct_clp, "BgColorL");
		IniFile->WriteString( sct_clp, "FgColorT");
		IniFile->WriteString( sct_clp, "BgColorT");
		IniFile->WriteString( sct_clp, "FgColorV");
		IniFile->WriteString( sct_clp, "BgColorV");
		IniFile->WriteString( sct_clp, "CtrlColor");
		IniFile->WriteString( sct_clp, "LnCtColor");
		IniFile->WriteBool(   sct_clp, "ShowLnCt",		false);
		IniFile->WriteInteger(sct_clp, "PreviewLn", 	0);
		IniFile->WriteInteger(sct_clp, "Transparent", 	255);
		IniFile->WriteString( sct_clp, "ExceptWord1");
		IniFile->WriteString( sct_clp, "TextDataBtn1");
		IniFile->WriteString( sct_clp, "TextDataBtn2");
		IniFile->WriteString( sct_clp, "TextDataBtn3");
		IniFile->WriteString( sct_clp, "TextDataBtn4");
		IniFile->WriteString( sct_clp, "TextDataBtn5");
		IniFile->WriteString( sct_clp, "TextDataBtn6");
		IniFile->WriteString( sct_clp, "TextDataBtn7");
		IniFile->WriteString( sct_clp, "TextDataBtn8");

		for (int i=1; i<=5; i++) IniFile->WriteString("CmdKwd" + IntToStr(i), "Key");
	}

	//GfB^
	IniEditor = IniFile->ReadString(sct_gen, "Editor");
	if (IniEditor.IsEmpty()) IniEditor = "notepad.exe";
	tmpstr = IniEditor.UpperCase();
	QxEditor = (tmpstr.Pos("QXW32.EXE")>0 || tmpstr.Pos("QXLOAD.EXE")>0)? IniEditor : EmptyStr;
	if (QxEditor.IsEmpty()) QxEditor = IniFile->ReadString(sct_gen, "QxEditor");

	//Migemo
	delete usr_Migemo;
	usr_Migemo = new MigemoUnit(rel_to_absdir(IniFile->ReadString(sct_gen, "MigemoDir")));

	//ǎ
	WallBmpName = IniFile->ReadString(sct_gen, "WallBmpName", ExePath + "HotQWall.BMP");

	//WM_PASTE œ\tsNX̃Xg
	PasteClassList->Clear();
	//ftHg
	TStringDynArray def_lst = SplitString(DEF_PASTE_CLS, ";");
	for (int i=0; i<def_lst.Length; i++) PasteClassList->Add(def_lst[i]);
	//[Uݒ
	TStringDynArray usr_lst = SplitString(IniFile->ReadString(sct_gen, "WmPasteClass"), ";");
	for (int i=0; i<usr_lst.Length; i++) PasteClassList->Add(usr_lst[i]);

	//̃zbgL[^R}h`Uj
	for (int i=0; i<HKeyList->Count; i++) {
		HKeyRec *kp = (HKeyRec*)HKeyList->Items[i];
		delete kp;
	}
	int kwt = IniFile->ReadInteger(sct_gen, "KeyWait",	50);

	//VɃzbgL[o^
	HKeyList->Clear();
	CmdKwTopIndex = -1;
	for (int p=0; p<2; p++) {
		int max_itm = (p==0)? MAX_HOTKEY : MAX_CMDKW;
		if (p==1) CmdKwTopIndex = HKeyList->Count;
		for (int i=1; i<=max_itm; i++) {
			HKeyRec *kp;
			UnicodeString sct;
			//zbgL[
			if (p==0) {
				sct = "HotKey" + IntToStr(i);
				UnicodeString hkstr = IniFile->ReadString(sct, "Key");
				if (hkstr.IsEmpty()) continue;
				kp = new HKeyRec(Handle, ID_HOTQ_BASE + i, text_to_shortcut(hkstr));
			}
			//R}hL[[h
			else {
				sct = "CmdKwd" + IntToStr(i);
				UnicodeString kwstr = IniFile->ReadString(sct, "Key");
				if (kwstr.IsEmpty()) continue;
				kp = new HKeyRec(Handle, ID_KWCOM_BASE + i, text_to_shortcut(""));
				kp->KeyWord  = kwstr;
				kp->ico_file = IniFile->ReadString(sct, "Icon");
			}

			if (kp->reg_ok) {
				kp->description = IniFile->ReadString(sct, "Description");
				kp->key_wait	= kwt;
				kp->sound		= IniFile->ReadString(sct, "Sound");
				kp->wall_paper	= IniFile->ReadString(sct, "WallPaper");
				kp->command 	= IniFile->ReadString(sct, "Command").UpperCase();
				if (kp->command.IsEmpty()) {
					for (int j=0; j<MAX_REG_WND; j++) {
						UnicodeString nstr = IntToStr(j + 1);
						//ANeBu
						kp->act_class[j] = IniFile->ReadString(sct, "ActivateWndClass"  + nstr);
						kp->act_title[j] = IniFile->ReadString(sct, "ActivateWndTitle"  + nstr);
						kp->act_tit_r[j] = IniFile->ReadString(sct, "ActivateWndTitleR" + nstr);
						kp->act_tit_m[j] = IniFile->ReadString(sct, "ActivateWndTitleM" + nstr);
						//s
						kp->exe_file[j]
							= IniFile->ReadString(sct, "Execute" + nstr);
						if (!kp->exe_file[j].IsEmpty()) {
							kp->exe_param[j] = IniFile->ReadString(sct, "ExeParam" + nstr);
							kp->exe_dir[j]	 = IniFile->ReadString(sct, "ExeDir"   + nstr);
						}
						//L[o
						kp->send_key[j]  = IniFile->ReadString(sct, "SendKey" + nstr);
						//ŏ
						kp->min_class[j] = IniFile->ReadString(sct, "MinimizeWndClass"  + nstr);
						kp->min_title[j] = IniFile->ReadString(sct, "MinimizeWndTitle"  + nstr);
						kp->min_tit_r[j] = IniFile->ReadString(sct, "MinimizeWndTitleR" + nstr);
						kp->min_tit_m[j] = IniFile->ReadString(sct, "MinimizeWndTitleM" + nstr);
						//
						kp->cls_class[j] = IniFile->ReadString(sct, "CloseWndClass"  + nstr);
						kp->cls_title[j] = IniFile->ReadString(sct, "CloseWndTitle"  + nstr);
						kp->cls_tit_r[j] = IniFile->ReadString(sct, "CloseWndTitleR" + nstr);
						kp->cls_tit_m[j] = IniFile->ReadString(sct, "CloseWndTitleM" + nstr);
					}
					//QX}N
					kp->qx_macro = IniFile->ReadString(sct, "QxMacro");
				}
				HKeyList->Add(kp);

			}
			//o^Ɏs
			else {
				// ErrorOɏo
				IniFile->WriteString("ErrorLog", sct, "o^s " + DateTimeToStr(Now()));
				delete kp;
			}
		}
	}

	//------------------------------
	//R}h`[̐ݒ
	//------------------------------
	if (CmdKwFont) delete CmdKwFont;
	CmdKwFont = IniFile->ReadFontInf(sct_cmd, Font);
	CmdNoTbar = IniFile->ReadBool(   sct_cmd, "NoTitleBar");
	CmdFlat	  = IniFile->ReadBool(   sct_cmd, "FlatBorder");

	//LaunchDir ̃V[gJbgt@Co^
	UnicodeString launch_dir = IniFile->ReadString(sct_cmd, "LaunchDir");
	if (!launch_dir.IsEmpty()) {
		if (ExtractFileDrive(launch_dir).IsEmpty()) launch_dir = ExePath + launch_dir;
		std::unique_ptr<TStringList> FilList(new TStringList());
		get_filelist(launch_dir, FilList.get(), "LNK", true);
		for (int i=0; i<FilList->Count; i++) {
			HKeyRec *kp = new HKeyRec(Handle, ID_KWCOM_BASE + MAX_CMDKW + i + 1, text_to_shortcut(""));
			kp->KeyWord = ChangeFileExt(ExtractFileName(FilList->Strings[i]), EmptyStr);
			kp->exe_file[0] = FilList->Strings[i];
			HKeyList->Add(kp);
		}
	}
	if (CmdLncForm) CmdLncForm->BorderStyle = CmdNoTbar? bsNone : bsToolWindow;

	//------------------------------
	//Nbv{[h
	//------------------------------
	if (ClipBdList) ClipBdList->RecyclePrc();

	//------------------------------
	//|bvAbvj[̐ݒ
	//------------------------------
	if (PopupFont) delete PopupFont;
	PopupFont	  = IniFile->ReadFontInf(sct_pop, Font);
	ColPopFgL	  = IniFile->ReadColor(  sct_pop, "FgColorL", 		clMenuText);
	ColPopBgL	  = IniFile->ReadColor(  sct_pop, "BgColorL", 		clMenu);
	ColPopSelFgL  = IniFile->ReadColor(  sct_pop, "SelFgColorL",	clHighlightText);
	ColPopSelBgL  = IniFile->ReadColor(  sct_pop, "SelBgColorL",	clHighlight);
	ColPopFgP	  = IniFile->ReadColor(  sct_pop, "FgColorP", 		clMenuText);
	ColPopBgP	  = IniFile->ReadColor(  sct_pop, "BgColorP", 		clMenu);
	ColPopSelFgP  = IniFile->ReadColor(  sct_pop, "SelFgColorP",	clHighlightText);
	ColPopSelBgP  = IniFile->ReadColor(  sct_pop, "SelBgColorP",	clHighlight);
	ColPopAk	  = IniFile->ReadColor(  sct_pop, "AkColor",		clMenuText);
	ColPopSelAk   = IniFile->ReadColor(  sct_pop, "SelAkColor",		clHighlightText);
	PopPos.x	  = IniFile->ReadInteger(sct_pop, "PosX", 			-1);
	PopPos.y	  = IniFile->ReadInteger(sct_pop, "PosY", 			-1);;
	PopSelRaised  = IniFile->ReadBool(   sct_pop, "SelRaised"		);
	NoAkUnderline = IniFile->ReadBool(   sct_pop, "NoAkUnderline"	);
	AkBold		  = IniFile->ReadBool(   sct_pop, "AkBold"			);
	PopMinWidth   = IniFile->ReadInteger(sct_pop, "MinWidth",  		0);
	PopItemHeight = IniFile->ReadInteger(sct_pop, "ItemHeight", 	0);

	//̃|bvAbvj[ڂU폜
	while (PopupLauncher->Items->Count>0)
		PopupLauncher->Items->Delete(PopupLauncher->Items->Count - 1);

	//PpopDir ̃V[gJbgt@Co^
	PopupDir  = IniFile->ReadString(sct_pop, "PopupDir");
	PopSorted = IniFile->ReadBool(  sct_pop, "Sort");
	if (!PopupDir.IsEmpty()) {
		if (ExtractFileDrive(PopupDir).IsEmpty()) PopupDir = ExePath + PopupDir;
		RegisterDir(PopupDir, PopupLauncher->Items);
	}

	//j[`t@C̓o^
	PopupFile = IniFile->ReadString(sct_pop, "PopupFile");
	if (get_file_name_r(PopupFile)) {
		std::unique_ptr<TStringList> fbuf(new TStringList());
		fbuf->LoadFromFile(PopupFile);
		//RgsAs̋󔒓͂炩ߍ폜Ă
		int i = 0;
		while (i<fbuf->Count) {
			tmpstr = Trim(fbuf->Strings[i]);
			if (tmpstr.IsEmpty() || tmpstr[1]==';') fbuf->Delete(i); else i++;
		}

		TMenuItem *pp = PopupLauncher->Items;
		bool no_sln = (fbuf->IndexOf("--")==-1);	// -- s?
		bool rq_break = false;	//񕪊vNA
		int  ptype = MITM_LAUNCH;

		for (int i=0; i<fbuf->Count; i++) {
			tmpstr = Trim(fbuf->Strings[i]);
			//SĂ\t
			if (i==0 && no_sln) {
				ptype = MITM_PASTE;
			}
			//\t
			else if (tmpstr=="--") {
				if (ptype==MITM_PASTE) continue;
				ptype = MITM_PASTE;
				if (pp->Count==0) continue;
				if (i>0) {
					if (fbuf->Strings[i - 1] == "|") continue;
				}
				if (i<(fbuf->Count - 1)) {
					if (fbuf->Strings[i + 1] == "|") continue;
				}
				if (i==(fbuf->Count - 1)) continue;
				//`[ڂƂ̊ԂɃZp[^}
				TMenuItem *ip = new TMenuItem(PopupLauncher);
				ip->Caption    = "-";
				ip->OnDrawItem = PopDrawItem;
				ip->Tag 	   = MITM_LAUNCH | MITM_PASTE | MITM_SEP;
				pp->Add(ip);
				continue;
			}

			//ڒǉ
			//񕪊
			if (tmpstr=="|") {
				rq_break = true; continue;
			}
			//Kw߂
			else if (tmpstr=="<") {
				if (pp!=PopupLauncher->Items) pp = pp->Parent;
			}
			//Kw
			else if (tmpstr[1]=='>') {
				TMenuItem *ip = new TMenuItem(PopupLauncher);
				ip->Caption 	  = tmpstr.Delete(1, 1);
				ip->OnMeasureItem = PopItemMeasureItem;
				ip->OnDrawItem	  = PopDrawItem;
				if (rq_break) ip->Break = mbBarBreak;
				ip->Tag 		  = ptype | MITM_ITM;
				pp->Add(ip);
				pp = ip;
			}
			else {
				TMenuItem *ip = new TMenuItem(PopupLauncher);
				ip->OnDrawItem = PopDrawItem;
				//Zp[^
				if (tmpstr=="-") {
					ip->Caption = "-";
					ip->Tag 	= ptype | MITM_SEP;
				}
				//Zp[^̍J
				else if (tmpstr=="#-") {
					ip->Caption = "-";
					ip->Tag 	= ptype | MITM_DMS;
				}
				//ڂ̍J
				else if (tmpstr=="#+") {
					ip->Caption 	  = "-";
					ip->OnMeasureItem = PopItemMeasureItem;
					ip->Tag 		  = ptype | MITM_DMH;
				}
				else {
					UnicodeString capstr = get_tkn(tmpstr,"\t");
					UnicodeString prmstr = get_tkn_r(tmpstr, "\t");
					if (!prmstr.IsEmpty())
						ip->Caption = capstr + "\t" + ReplaceStr(prmstr,"&", "\x02");
						//ANZ[^Fh~̂ "&"  "\x02" ֈꎞIɕϊ
					else
						ip->Caption = capstr;
					if ((ptype & MITM_LAUNCH)!=0)
						ip->OnClick	  = LauncherItemClick;
					else
						ip->OnClick   = PopPasteItemClick;
					ip->OnMeasureItem = PopItemMeasureItem;
					ip->Tag 		  = ptype | MITM_ITM;
				}
				if (rq_break) ip->Break = mbBarBreak;
				pp->Add(ip);
			}
			rq_break = false;
		}
	}

	//^XNgCACR̐ݒ
	NoTrayIcon = IniFile->ReadBool(sct_gen, "NoTrayIcon", false);
	try {
		TrayIcon1->Hint    = Application->Title;
		TrayIcon1->Visible = !NoTrayIcon;
		DelayTrayIcon	   = 0;
		Timer1->Enabled    = false;
	}
	catch (...) {
		//sꍇ10bɕ\݁AȌ110񃊃gC
		DelayTrayIcon	   = 10;
		RetryTrayIcon	   = 10;
		Timer1->Interval   = 1000;
		Timer1->Enabled    = true;
	}

	IniFile->UpdateFile();	//ύX΍XV

	Screen->Cursor = crDefault;
}

//---------------------------------------------------------------------------
void __fastcall THotQMainForm::FormCreate(TObject *Sender)
{
	ExePath = ExtractFilePath(Application->ExeName);

	//X[ACR擾
	SHFILEINFO sif;
	::SHGetFileInfo(Application->ExeName.c_str(), FILE_ATTRIBUTE_ARCHIVE,
		&sif, sizeof(SHFILEINFO), SHGFI_ICON|SHGFI_SMALLICON);
	hSmallIcon = sif.hIcon;

	//WM_PASTE œ\tsNX̃Xg̏
	PasteClassList = new TStringList();
	PasteClassList->Sorted		  = true;
	PasteClassList->CaseSensitive = false;
	PasteClassList->Duplicates	  = System::Classes::dupIgnore;

	//o[W\ݒ
	VerLabel->Caption = "Version " + get_VersionStr(Application->ExeName);
	WebLabel->Caption = SUPPORT_URL;

	//ݒt@Cǂݍ
	PopupFont = CmdKwFont = NULL;
	HKeyList  = new TList();
	RecyclePrc();

	//QX}NX^[^EXbh쐬
	QxMacStarter = new TQxMacStarter(false);
}

//---------------------------------------------------------------------------
void __fastcall THotQMainForm::FormDestroy(TObject *Sender)
{
	QxMacStarter->Terminate();

	//ݒ̔j
	for (int i=0; i<HKeyList->Count; i++) {
		HKeyRec *kp = (HKeyRec*)HKeyList->Items[i];
		delete kp;
	}
	delete HKeyList;

	IniFile->UpdateFile();
	delete IniFile;

	delete PasteClassList;

	delete usr_Migemo;

	delete PopupFont;
	delete CmdKwFont;
	if (hSmallIcon) ::DestroyIcon(hSmallIcon);
}

//---------------------------------------------------------------------------
//WindowsȈ
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::WmQueryEndSession(TMessage& msg) {
	if (ClipBdList) ClipBdList->SaveHistList();

	Perform(WM_CLOSE, 0, 0);
	msg.Result = 1;
}

//---------------------------------------------------------------------------
//zbgL[^R}h`[s
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::WmHotKey(TMessage &msg)
{
	//\t̂߂
	//炩ߌ݂̃tH[JX擾Ă
	hLastWnd	  = ::GetForegroundWindow();
	LastThreadID  = ::GetWindowThreadProcessId(hLastWnd, NULL);
	DWORD cur_tid = ::GetCurrentThreadId();
	if (cur_tid!=LastThreadID && ::AttachThreadInput(cur_tid, LastThreadID, TRUE)) {
		hLastFocus = ::GetFocus();
		::AttachThreadInput(cur_tid, LastThreadID, FALSE);
	}
	else {
		hLastFocus = NULL;
	}

	//s
	bool show_ver  = false;
	bool show_hlst = false;
	for (int i=0; i<HKeyList->Count; i++) {
		HKeyRec *kp = (HKeyRec*)HKeyList->Items[i];
		if ((int)msg.WParam!=kp->id) continue;

		//TEhĐ
		UnicodeString file_name = kp->sound;
		if (get_file_name_r(file_name)) ::sndPlaySound(file_name.c_str(),SND_ASYNC);

		//ǎύX
		if (!kp->wall_paper.IsEmpty()) {
			file_name = SameText(kp->wall_paper, "none")? EmptyStr : kp->wall_paper;
			if (!get_file_name_r(file_name)) {
				::SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, (LPVOID)_T(""),
					SPIF_UPDATEINIFILE|SPIF_SENDWININICHANGE);
			}
			else {
				UnicodeString wpfext = ExtractFileExt(file_name);
				bool flag = false;
				if (SameText(wpfext, ".jpg") || SameText(wpfext, ".png") || SameText(wpfext, ".gif")) {
					std::unique_ptr<Graphics::TBitmap> bmpimg(new Graphics::TBitmap());
					if (WIC_load_image(file_name, bmpimg.get())) {
						bmpimg->SaveToFile(WallBmpName);
						flag = true;
					}
				}
				else if (SameText(wpfext, ".bmp")) {
					flag = ::CopyFile(file_name.c_str(), WallBmpName.c_str(), FALSE);
				}
				if (flag) {
					::SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, WallBmpName.c_str(),
						SPIF_UPDATEINIFILE|SPIF_SENDWININICHANGE);
				}
			}
		}

		//ݒēǍ
		if (SameText(kp->command, "RECYCLE")) {
			RecyclePrc();
		}
		//|bvAbvj[\
		else if (SameText(kp->command, "POPUPMENU")) {
			if (ClipBdList->Visible) ClipBdList->Hide();
			POINT p;
			if (PopPos.x==-1 || PopPos.y==-1)
				::GetCursorPos(&p);
			else
				p = PopPos;
			set_Foreground();
			Application->ProcessMessages();
			PopOK = false;
			PopupLauncher->Popup(p.x, p.y);
			if (!PopOK) set_Foreground(hLastWnd);
		}
		//R}h`[
		else if (SameText(kp->command, "CMDLAUNCHER")) {
			if (!CmdLncForm->Visible) {
				CmdLncForm->Show();
				set_Foreground();
			}
			else {
				CmdLncForm->Hide();
			}
		}
		//Nbv{[h
		else if (SameText(kp->command, "CLIPBOARD")) {
			if (!ClipBdList->Visible) ClipBdList->Show();
			set_Foreground();
		}
		//
		else if (SameText(kp->command, "CLIPBOARD_C")) {
			ClipBdList->PageControl1->ActivePage = ClipBdList->ClipSheet;
			if (!ClipBdList->Visible)
				ClipBdList->Show();
			else
				ClipBdList->PageControl1Change(NULL);
			set_Foreground();
		}
		//Nbv{[hɋǉ
		else if (StartsText("FORCE_CLIP", kp->command)) {
			if (!ClipBdList->ClipEnabled) ClipBdList->AddHistList(true);
		}
		//^
		else if (StartsText("CLIPBOARD_T", kp->command)) {
			ClipBdList->PageControl1->ActivePage = ClipBdList->TextSheet;
			if (!ClipBdList->Visible) ClipBdList->Show();
			UnicodeString idxstr = get_tkn_r(kp->command, "CLIPBOARD_T");
			if (!idxstr.IsEmpty())
				ClipBdList->ChangeTextData(idxstr.ToIntDef(1) - 1);
			else
				ClipBdList->PageControl1Change(NULL);
			set_Foreground();
		}
		//XN[ZCo[N
		else if (SameText(kp->command, "SCREENSAVE")) {
			BOOL act = FALSE;
			if (::SystemParametersInfo(SPI_GETSCREENSAVEACTIVE, 0, &act, 0) == TRUE) {
				if (act) ::SendMessage(Handle, WM_SYSCOMMAND, SC_SCREENSAVE, 0);
			}
		}
		//ݒt@C̕ҏW
		else if (SameText(kp->command, "EDIT_INI")) {
			PopEditItemClick(NULL);
		}
		//|bvAbvj[`t@C̕ҏW
		else if (SameText(kp->command, "EDIT_POPUP")) {
			PopDefItemClick(NULL);
		}
		//o[W\
		else if (SameText(kp->command, "VERSION")) {
			show_ver = true;
		}
		//zbgL[ꗗ\
		else if (SameText(kp->command, "HOTKEY_LIST")) {
			show_hlst = true;
		}
		//I
		else if (SameText(kp->command, "EXIT")) {
			Close();
		}
		//̑
		else {
			kp->DoProc();
		}
		break;
	}

	if (!CmdLncForm->Visible) {
		::ShowWindow(Application->Handle, SW_HIDE);
		::ShowWindow(Handle, SW_HIDE);
	}

	if (show_ver) {
		Show();
		set_Foreground();
	}

	if (show_hlst) {
		HotKeyHelp->Show();
		set_Foreground();
	}
	else {
		HotKeyHelp->Hide();
	}

	msg.Result = 0;
}

//---------------------------------------------------------------------------
//dNꂽ HotQ R}hC̓e󂯎
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::WmCopyData(TMessage& msg)
{
	COPYDATASTRUCT *cd = (COPYDATASTRUCT*)(msg.LParam);
	if (cd->dwData==1) {
		UnicodeString clbuf = (LPTSTR)cd->lpData;
		if (clbuf=="-R") RecyclePrc();
	}
	msg.Result = 0;
}

//---------------------------------------------------------------------------
//^C}[
// gCACR̒x\
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::Timer1Timer(TObject *Sender)
{
	if (DelayTrayIcon>0) {
		DelayTrayIcon--;
		if (DelayTrayIcon==0) {
			Timer1->Enabled = false;
			try {
				TrayIcon1->Visible = false;
				TrayIcon1->Visible = !NoTrayIcon;
			}
			catch (...) {
				if (RetryTrayIcon>0) {
					RetryTrayIcon--;
					DelayTrayIcon	= 10;	//sꍇ1ɃgC
					Timer1->Enabled = true;
				}
			}
		}
	}
	else {
		Timer1->Enabled = false;
	}
}

//---------------------------------------------------------------------------
//|bvAbvj[ڂ̃TCY𒲐
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::PopItemMeasureItem(TObject *Sender,
      TCanvas *ACanvas, int &Width, int &Height)
{
	TMenuItem *mp = (TMenuItem*)Sender;
	UnicodeString tmpstr = exp_FormatStr(get_tkn(mp->Caption, "\t"));
	if (PopupFont) ACanvas->Font->Assign(PopupFont);
	Width = ACanvas->TextWidth(tmpstr) + 12;

	int mhi;
	if (PopupFont) {
		mhi = ACanvas->TextHeight("|");
	}
	else {
		NONCLIENTMETRICS ncm;
		ncm.cbSize = sizeof(NONCLIENTMETRICS);
		::SystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(NONCLIENTMETRICS), &ncm, 0);
		mhi = ncm.iMenuHeight;
	}

	if ((mp->Tag & MITM_DMH)!=0 || (mp->Tag & MITM_ITM)!=0) Height = mhi;

	if (PopSelRaised) Height += 2;
	if (PopItemHeight>Height) Height = PopItemHeight;
	if (Width<PopMinWidth)	  Width  = PopMinWidth;
}

//---------------------------------------------------------------------------
//|bvAbvj[ڂ`
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::PopDrawItem(TObject *Sender,
      TCanvas *ACanvas, const TRect &ARect, bool Selected)
{
	TMenuItem *mp = (TMenuItem*)Sender;
	TFont *fp  = ACanvas->Font;
	TBrush *bp = ACanvas->Brush;

	if (PopupFont) fp->Assign(PopupFont);

	bool l_flag = ((mp->Tag & MITM_LAUNCH) != 0);
	//I
	if (Selected) {
		bp->Color = l_flag? ColPopSelBgL : ColPopSelBgP;
		fp->Color = l_flag? ColPopSelFgL : ColPopSelFgP;
	}
	//I
	else {
		bp->Color = l_flag? ColPopBgL : ColPopBgP;
		fp->Color = l_flag? ColPopFgL : ColPopFgP;
	}
	ACanvas->FillRect(ARect);

	TRect rc = ARect;
	int p;

	//Zp[^
	if ((mp->Tag & MITM_SEP)!=0) {
		rc.Top += (((mp->Tag & MITM_DMH)!=0)? (rc.Bottom - rc.Top)/2 : 4);
		if ((mp->Tag & MITM_PASTE)!=0) {
			bp->Color = ColPopBgP;
			ACanvas->FillRect(rc);
		}
		::DrawEdge(ACanvas->Handle, &rc, EDGE_ETCHED, BF_TOP);
	}
	//
	else if ((mp->Tag & MITM_DMH)==0 && (mp->Tag & MITM_DMS)==0) {
		if (Selected && PopSelRaised) ::DrawEdge(ACanvas->Handle, &rc, EDGE_RAISED, BF_RECT);
		bp->Style = bsClear;
		rc.Left += 8;
		rc.Top	+= ((ARect.Bottom - ARect.Top) - ACanvas->TextHeight("|"))/2;
		UnicodeString tmpstr = exp_FormatStr(get_tkn(mp->Caption, "\t"));
		p = tmpstr.Pos("&");
		//ANZ[^
		if (p==0) {
			ACanvas->TextOut(rc.Left, rc.Top, tmpstr);
		}
		//ANZ[^L
		else {
			ACanvas->TextOut(rc.Left, rc.Top, tmpstr.SubString(1, p - 1));
			rc.Left += ACanvas->TextWidth(tmpstr.SubString(1, p - 1));
			tmpstr.Delete(1, p - 1);
			TColor sColor = fp->Color;
			fp->Color = Selected? ColPopSelAk : ColPopAk;
			if (!NoAkUnderline) fp->Style = fp->Style << fsUnderline;
			bool bflag = (AkBold && !fp->Style.Contains(fsBold));
			if (bflag) fp->Style = fp->Style << fsBold;
			ACanvas->TextOut(rc.Left, rc.Top, tmpstr.SubString(2, 1));
			rc.Left += ACanvas->TextWidth(tmpstr.SubString(2, 1));
			fp->Style = fp->Style >> fsUnderline;
			if (bflag) fp->Style = fp->Style >> fsBold;
			fp->Color = sColor;
			ACanvas->TextOut(rc.Left, rc.Top, tmpstr.Delete(1, 2));
		}
	}
}

//---------------------------------------------------------------------------
//`[ڂ̎s
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::LauncherItemClick(TObject *Sender)
{
	TMenuItem *mp = (TMenuItem*)Sender;
	UnicodeString tmpstr = mp->Caption;
	int p = tmpstr.Pos("\t");
	//PopupDir o^ꂽV[gJbg
	if (p==0) {
		UnicodeString lnkfil = mp->Caption + ".lnk";
		while (mp->Parent != PopupLauncher->Items) {
			lnkfil = mp->Parent->Caption + "\\" + lnkfil;
			mp = mp->Parent;
		}
		lnkfil = PopupDir + "\\" + lnkfil;
		execute_ex(lnkfil);
	}
	//j[`o^ꂽt@C
	else {
		tmpstr = Trim(get_tkn_r(tmpstr, "\t")); if (tmpstr.IsEmpty()) return;
		tmpstr = ReplaceStr(tmpstr, "\x02", "&");
		//ŏ̔pXy[X( " l)
		UnicodeString cmd, prm;
		bool qflag = false;
		for (int i=1; i<=tmpstr.Length(); i++) {
			if (!qflag) {
				if (tmpstr[i]==' ') {
					cmd = Trim(tmpstr.SubString(1, i));	//R}h
					prm = Trim(tmpstr.Delete(1, i));	//p[^
					break;
				}
				else if (tmpstr[i]=='\"') {
					qflag = true;
				}
			}
			else if (tmpstr[i]=='\"') {
				qflag = false;
			}
		}
		if (cmd.IsEmpty()) cmd = tmpstr;
		if (!execute_ex(cmd, prm)) msgbox_ERR("[" + cmd + "] ̎sɎs܂");
	}
}

//---------------------------------------------------------------------------
//|bvAbvj[當\t
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::PopPasteItemClick(TObject *Sender)
{
	if (hLastWnd==NULL) return;

	UnicodeString tmpstr = ((TMenuItem *)Sender)->Caption;
	UnicodeString pststr = get_tkn_r(tmpstr, "\t");
	if (pststr.IsEmpty())
		pststr = tmpstr;
	else
		pststr = ReplaceStr(pststr, "\x02", "&");

	if (!pststr.IsEmpty()) {
		Clipboard()->AsText = exp_FormatStr(pststr);
		PasteClipboard();
	}
}

//---------------------------------------------------------------------------
void __fastcall THotQMainForm::PopupMenu1Popup(TObject *Sender)
{
	PopEditItem->Enabled  = !IniEditor.IsEmpty();
	PopDefItem->Enabled   = (!IniEditor.IsEmpty() && !PopupFile.IsEmpty());
	PopAboutItem->Visible = !Visible;
}

//---------------------------------------------------------------------------
//OK
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::OkButtonClick(TObject *Sender)
{
	Hide();
}
//---------------------------------------------------------------------------
//Weby[WJ
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::WebLabelClick(TObject *Sender)
{
	Hide();
	execute_ex(SUPPORT_URL);
}

//---------------------------------------------------------------------------
//ݒt@C̕ҏW
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::PopEditItemClick(TObject *Sender)
{
	ClipBdList->Hide();
	Hide();
	EditFile(IniFile->FileName);
}
//---------------------------------------------------------------------------
//|bvAbvj[`t@C̕ҏW
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::PopDefItemClick(TObject *Sender)
{
	Hide();
	EditFile(PopupFile);
}

//---------------------------------------------------------------------------
//`̍ēǍ
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::PopRecycleItemClick(TObject *Sender)
{
	Hide();
	RecyclePrc();
}

//---------------------------------------------------------------------------
//zbgL[ꗗ
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::HotkeyListItemClick(TObject *Sender)
{
	HotKeyHelp->Show();
}
//---------------------------------------------------------------------------
//o[W\
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::PopAboutItemClick(TObject *Sender)
{
	Show();
}
//---------------------------------------------------------------------------
//I
//---------------------------------------------------------------------------
void __fastcall THotQMainForm::PopExitItemClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
